//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#property link "http://forexbig.ru"
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//+------------------------------------------------------------------+
//|                                                       KST_v1.mq4 |
//|                                  Copyright  2007, Forex-TSD.com |
//|                                     Written by IgorAD & Linuxser |                                  
//|                     According to Pring's Formulas (www.pring.com)|
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DodgerBlue
#property indicator_width1  2
//---- input parameters
extern int KSTMode   = 0;
extern string  s1=" 0. 5-Minute Bar Short-term KST";
extern string  s2=" 1. 5-Minute Bar Long-term KST";
extern string  s3=" 2. 10/15-Minute Bar Short-term KST";
extern string  s4=" 3. 10/15-Minute Bar Long-term KST";
extern string  s5=" 4. Short-term Tick KST";
extern string  s6=" 5. Daily KST Simple Moving Average";
extern string  s7=" 6. Long-term Monthly KST Simple Moving Average";
extern string  s8=" 7. Intermediate KST Simple Moving Average";
extern string  s9=" 8. Intermediate KST Exponential Moving Average";
extern string  s10=" 9. Long-term KST Exponential Moving Average";
extern string  s11=" 10. Short-term KST Weekly Exponential Moving Average";
//---- buffers
double KST[];
double ROC1[];
double ROC2[];
double ROC3[];
double ROC4[];

int l1,l2,l3,l4,m1,m2,m3,m4,MAMode;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   IndicatorBuffers(5);
   SetIndexBuffer(0,KST);
   SetIndexBuffer(1,ROC1);
   SetIndexBuffer(2,ROC2);
   SetIndexBuffer(3,ROC3);
   SetIndexBuffer(4,ROC4);
   
//---- name for DataWindow and indicator subwindow label
   short_name="KST ("+KSTMode+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   if(KSTMode == 0) // 5-Minute Bar Short-term KST
   {
   //(Mov(ROC(C,6,%),10,S)*1)+(Mov(ROC(C,10,%),10,S)*2)+(Mov(ROC(C,15,%),8,S)*3)+(Mov(ROC(C,20,%),15,S)*4)
   l1 =  6; l2 = 10; l3 = 15; l4 = 20;
   m1 = 10; m2 = 10; m3 =  8; m4 = 15; 
   MAMode = MODE_SMA;
   }
   else
   if(KSTMode == 1) // 5-Minute Bar Long-term KST
   {
   //(Mov(ROC(C,60,%),30,S)*1)+(Mov(ROC(C,90,%),40,S)*2)+(Mov(ROC(C,120,%),60,S)*3)+(Mov(ROC(C,200,%),100,S)*4)
   l1 = 60; l2 = 90; l3 = 120; l4 = 200;
   m1 = 30; m2 = 40; m3 = 60; m4 = 100; 
   MAMode = MODE_SMA;
   } 
   else
   if(KSTMode == 2) // 10/15-Minute Bar Short-term KST
   {
   //(Mov(ROC(C,10,%),10,S)*1)+(Mov(ROC(C,15,%),10,S)*2)+(Mov(ROC(C,20,%),10,S)*3)+(Mov(ROC(C,30,%),15,S)*4)
   l1 = 10; l2 = 15; l3 = 20; l4 = 30;
   m1 = 10; m2 = 10; m3 = 10; m4 = 15; 
   MAMode = MODE_SMA;
   } 
   else
   if(KSTMode == 3) // 10/15-Minute Bar Long-term KST
   {
   //(Mov(ROC(C,30,%),15,S)*1)+(Mov(ROC(C,45,%),20,S)*2)+(Mov(ROC(C,60,%),30,S)*3)+(Mov(ROC(C,90,%),45,S)*4)
   l1 = 30; l2 = 45; l3 = 60; l4 = 90;
   m1 = 15; m2 = 20; m3 = 30; m4 = 45; 
   MAMode = MODE_SMA;
   } 
   else
   if(KSTMode == 4) // Short-term Tick KST
   {
   //(Mov(ROC(C,12,%),10,S)*1)+(Mov(ROC(C,20,%),10,S)*2)+(Mov(ROC(C,30,%),8,S)*3)+(Mov(ROC(C,40,%),15,S)*4)
   l1 = 12; l2 = 20; l3 = 30; l4 = 40;
   m1 = 10; m2 = 10; m3 =  8; m4 = 15; 
   MAMode = MODE_SMA;
   } 
   else
   if(KSTMode == 5) // Daily KST Simple Moving Average
   {
   //(Mov(Roc(C,10,%),10,S)*1) + (Mov(Roc(C,15,%),10,S)*2) + (Mov(Roc(C,20,%),10,S)*3) + (Mov(Roc(C,30,%),15,S)*4)
   l1 = 10; l2 = 15; l3 = 20; l4 = 30;
   m1 = 10; m2 = 10; m3 = 10; m4 = 15; 
   MAMode = MODE_SMA;
   } 
   else
   if(KSTMode == 6) // Long-term Monthly KST Simple Moving Average
   {
   //(Mov(Roc(C,9,%),6,S)*1) + (Mov(Roc(C,12,%),6,S)*2) + (Mov(Roc(C,18,%),6,S)*3) + (Mov(Roc(C,24,%),9,S)*4)
   l1 = 9; l2 = 12; l3 = 18; l4 = 24;
   m1 = 6; m2 =  6; m3 =  6; m4 =  9; 
   MAMode = MODE_SMA;
   } 
   else
   if(KSTMode == 7) // Intermediate KST Simple Moving Average
   {
   //(Mov(Roc(C,10,%),10,S)*1) + (Mov(Roc(C,13,%),13,S)*2) + (Mov(Roc(C,15,%),15,S)*3) + (Mov(Roc(C,20,%),20,S)*4)
   l1 = 10; l2 = 13; l3 = 15; l4 = 20;
   m1 = 10; m2 = 13; m3 = 15; m4 = 20; 
   MAMode = MODE_SMA;
   } 
   else
   if(KSTMode == 8) // Intermediate KST Exponential Moving Average
   {
   //(Mov(Roc(C,10,%),10,E)*1) + (Mov(Roc(C,13,%),13,E)*2) + (Mov(Roc(C,15,%),15,E)*3) + (Mov(Roc(C,20,%),20,E)*4)
   l1 = 10; l2 = 13; l3 = 15; l4 = 20;
   m1 = 10; m2 = 13; m3 = 15; m4 = 20; 
   MAMode = MODE_EMA;
   } 
   else
   if(KSTMode == 9) // Long-term KST Exponential Moving Average
   {
   //(Mov(Roc(C,39,%),26,E)*1) + (Mov(Roc(C,52,%),26,E)*2) + (Mov(Roc(C,78,%),26,E)*3) + (Mov(Roc(C,104,%),39,E)*4)
   l1 = 39; l2 = 52; l3 = 78; l4 = 104;
   m1 = 26; m2 = 26; m3 = 26; m4 =  39; 
   MAMode = MODE_EMA;
   } 
   else
   if(KSTMode == 10) // Short-term KST Weekly Exponential Moving Average
   {
   //(Mov(Roc(C,3,%),3, E)*1) + (Mov(Roc(C,4,%),4, E)*2) + (Mov(Roc(C,6,%),6, E)*3) + (Mov(Roc(C,10,%),8, E)*4) 
   l1 = 3; l2 = 4; l3 = 6; l4 = 10;
   m1 = 3; m2 = 4; m3 = 6; m4 =  8; 
   MAMode = MODE_EMA;
   }  
//----
   SetIndexDrawBegin(0,l4+m4);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| KST                                                      |
//+------------------------------------------------------------------+
int start()
{
   int i,limit,counted_bars=IndicatorCounted();
//----
   if(Bars<=l4+m4) return(0);
//---- initial zero
   if ( counted_bars < 0 ) return(-1);
   if ( counted_bars ==0 ) limit=Bars-1;
   
   if ( counted_bars < 1 ) 
   
   for(i=1;i<=l4+m4;i++) 
   {
   KST[Bars-i]=0.0;
   ROC1[Bars-i]=0.0;
   ROC2[Bars-i]=0.0;
   ROC3[Bars-i]=0.0;
   ROC4[Bars-i]=0.0;
   }
//----
   if(counted_bars>0) limit=Bars-counted_bars;
   limit--;
     
   for(i=limit; i>=0; i--)
   {
   if(Close[i+l1]>0) ROC1[i] = (Close[i]/Close[i+l1]-1)*100;
   if(Close[i+l2]>0) ROC2[i] = (Close[i]/Close[i+l2]-1)*100;
   if(Close[i+l3]>0) ROC3[i] = (Close[i]/Close[i+l3]-1)*100;
   if(Close[i+l4]>0) ROC4[i] = (Close[i]/Close[i+l4]-1)*100;
   }
   
   for(i=limit; i>=0; i--)
   KST[i] = iMAOnArray(ROC1,0,m1,0,MAMode,i)   +
            iMAOnArray(ROC2,0,m2,0,MAMode,i)*2 +
            iMAOnArray(ROC3,0,m3,0,MAMode,i)*3 +
            iMAOnArray(ROC4,0,m4,0,MAMode,i)*4;
   
   return(0);
}
//+------------------------------------------------------------------+